//+------------------------------------------------------------------+
//|                                             AutoFibAutoTrend.mq4 |
//|                                                    zzuegg        |
//|                                       when-money-makes-money.com |
//+------------------------------------------------------------------+
#property copyright "ZigZagFibAutoTrend"
#property link      ""

#property indicator_chart_window
extern ENUM_TIMEFRAMES    TimeFrame  =  PERIOD_CURRENT;
input int InpDepth=12;     // Depth
input int InpDeviation=5;  // Deviation
input int InpBackstep=3;   // Backstep
extern bool ShowFib=true;
extern color FibColor=Red;
extern int   FibSize=1;

extern bool ShowFibFan=true;
extern color FibFanColor=Yellow;
extern int FibFanSize=1;

extern bool ShowTrend=true;
extern color TrendColor=Blue;
extern int TrendSize=2;

string fib1="";
string trend="";
string fibf1="";
int init()
  {
   fib1="fib1"+TimeFrame;
   trend="trend1"+TimeFrame; 
   fibf1="fibf1"+TimeFrame;  
   return(0);
  }

int deinit()
  {
   ObjectDelete(fib1);
   ObjectDelete(trend);
   ObjectDelete(fibf1);
   return(0);
  }


int start()
  {
   int    counted_bars=IndicatorCounted();
   static datetime curr=0;
   if(curr!=iTime(Symbol(),TimeFrame,0))
   {
      curr=iTime(Symbol(),TimeFrame,0);
      ObjectDelete(fib1);
      ObjectDelete(trend);
      double swing_value[4]={0,0,0,0};
      datetime swing_date[4]={0,0,0,0};
      int found=0;
      double tmp=0;
      int i=0;
      while(found<4)
      {
         if(iCustom(Symbol(),TimeFrame,"ZigZag",InpDepth,InpDeviation,InpBackstep,0,i)!=0)
         {
            swing_value[found]=iCustom(Symbol(),TimeFrame,"ZigZag",InpDepth,InpDeviation,InpBackstep,0,i);
            swing_date[found]=iTime(Symbol(),TimeFrame,i);
            found++;
         }
         i++;
      }
      ObjectDelete(trend);
      if(ShowTrend){
      ObjectCreate(trend,OBJ_CHANNEL,0,swing_date[3],swing_value[3],swing_date[1],swing_value[1],swing_date[2],swing_value[2]);
      ObjectSet(trend,OBJPROP_COLOR,TrendColor);
      ObjectSet(trend,OBJPROP_WIDTH,TrendSize);
      }
      ObjectDelete(fib1);
      if(ShowFib){
      ObjectCreate(fib1,OBJ_FIBO,0,swing_date[2],swing_value[2],swing_date[1],swing_value[1]);
      ObjectSet(fib1,OBJPROP_LEVELCOLOR,FibColor);      
      ObjectSet(trend,OBJPROP_LEVELWIDTH,FibSize);
      }
      ObjectDelete(fibf1);
      if(ShowFibFan){
      ObjectCreate(fibf1,OBJ_FIBOFAN,0,swing_date[2],swing_value[2],swing_date[1],swing_value[1]);
      ObjectSet(fibf1,OBJPROP_LEVELCOLOR,FibFanColor);      
      ObjectSet(fibf1,OBJPROP_LEVELWIDTH,FibFanSize); 
      }
   }   

  // Comment("Support us, donate on this website: www.when-money-makes-money.com/download");
   return(0);
  }